-- Script by TopNotch, PM for suggestions or bug reports
-- INITIAL (do not touch this) --
pl = {}

-- CONFIG --
owner = {95753} -- Owner has GM tag, but has an !rcon command. I added this since rcon is very powerful (crashing server etc).
gamemaster = {7844} --Put your USGN here
mod = {} -- Moderator USGN here
mod_wallhack = true--Set this to false if you don't want Moderators to use wallhack

color = { -- You can change this, or add some extra colors. Note: the last color mustn't have "," behind it! "\169" is a copyright icon.
	"\169255220000", -- CS2D (yellow) 1 
	"\169255255255", -- white 2
	"\169255000000", -- red 3
	"\169000255000", -- green 4
	"\169000000255", -- blue 5
	"\169220220220", -- light grey 6
	"\169064179162", -- PM - light blue 7
	"\169255025000", -- T 8
	"\169050150255", -- CT 9
	"\169100100100" -- pretty dark grey - tag 10
},

-- HOOKS --
addhook("join","_join")
addhook("say","_say")
addhook("serveraction","_serveraction")
addhook("clientdata","_clientdata")
addhook("menu","_menu")
addhook("startround","_startround")

-- FUNCS --
function _join(id) -- No need to change anything here
	pl[id] = {}
	pl[id].lvl = 1
	pl[id].status = "Player"
	pl[id].name = player(id,"name")
	pl[id].usgn = player(id,"usgn")
	pl[id].ip = player(id,"ip")
	pl[id].muted = false
	for _, usgn in ipairs(owner) do
		if player(id,"usgn")==usgn then
			pl[id].lvl = 15
			pl[id].status = "Owner"
			pl[id].tag = "[GM]" --Same tag
			pl[id].has_tag = true
		end
	end
	for _, usgn in ipairs(gamemaster) do
		if player(id,"usgn")==usgn then
			pl[id].lvl = 10
			pl[id].status = "Game Master"
			pl[id].tag = "[GM]"
			pl[id].has_tag = true
		end
	end
	for _, usgn in ipairs(mod) do
		if player(id,"usgn")==usgn then
			pl[id].lvl = 5
			pl[id].status = "Moderator"
			pl[id].tag = "[M]"
			pl[id].has_tag = true
		end
	end
	welcome(id)
end

function welcome(id)
	msg2(id,color[2].."Welcome, "..pl[id].name)
	if pl[id].usgn==0 then
		msg2(id,color[3].."You are not logged in!")
		msg2(id,color[3].."Please register and login into a USGN account!")
	elseif pl[id].lvl >= 5 then
		msg2(id,color[2].."You are logged in as "..color[4]..""..pl[id].usgn)
		msg2(id,color[2].."Your rank is "..color[4]..""..pl[id].status)
	end
end

function reload()
	msg(color[2].."Updating server scripts (mapchange) in: @C")
	timer(1000,"parse","sv_msg 5@C")
	timer(2000,"parse","sv_msg 4@C")
	timer(3000,"parse","sv_msg 3@C")
	timer(4000,"parse","sv_msg 2@C")
	timer(5000,"parse","sv_msg 1@C")
	timer(6000,"parse","map "..game("sv_map"))
end

function error(id,txt,error)
	if error==1 then
		msg2(id,color[3].."Command: "..txt)
		msg2(id,color[3].."Error: Insufficient privilege")
	elseif error==2 then
		msg2(id,color[3].."Command: "..txt)
		msg2(id,color[3].."Error: No player found with ID "..t)
	elseif error==3 then
		msg2(id,color[3].."Command: "..txt)
		msg2(id,color[3].."Error: You cannot ban bots")
	elseif error==4 then
		msg2(id,color[3].."Error: You are muted, you cannot talk")
	elseif error==5 then
		msg2(id,color[3].."Command: "..txt)
		msg2(id,color[3].."Error: Value is too high. 1-10 allowed")
	elseif error==6 then
		msg2(id,color[3].."Command: "..txt)
		msg2(id,color[3].."Error: Your score is already nullified")
	elseif error==7 then
		msg2(id,color[3].."Command: "..txt)
		msg2(id,color[3].."Error: Value is too high. 1-60 allowed")
	end
end

function _say(id,txt)
	if pl[id].muted == true then
		error(id,txt,4)
		return 1
	end
	if txt:sub(1,5)=="!kick" then
		if pl[id].lvl >= 5 then
			t = tonumber(txt:sub(7,8))
			local r = txt:sub(9)
			if not player(t,"exists") then error(id,txt,2) return 1 end
			parse('kick '..t..' "'..r)
			msg(color[2]..""..pl[id].name..""..color[1].." kicked "..color[2]..""..pl[t].name.." (Reason: "..r..")")
			return 1
		else
			error(id,txt,1)
			return 1
		end
	end
	if txt:sub(1,6)=="!banip" then
		if pl[id].lvl >= 5 then
			t = tonumber(txt:sub(8,9))
			r = txt:sub(10)
			if not player(t,"exists") then error(id,txt,2) return 1 end
			if player(t,"bot")==true then error(id,txt,3) return 1 end
			parse('banip '..player(t,"ip")..' 0 "'..r)
			msg(color[2]..""..pl[id].name..""..color[1].." banned (IP) "..color[2]..""..pl[t].name.." (Reason: "..r..")")
			return 1
		else
			error(id,txt,1)
			return 1
		end
	end
	if txt:sub(1,8)=="!banusgn" then
		if pl[id].lvl >= 5 then
			t = tonumber(txt:sub(10,11))
			r = txt:sub(12)
			if not player(t,"exists") then error(id,txt,2) return 1 end
			if player(t,"bot")==true then error(id,txt,3) return 1 end
			parse('banusgn '..player(t,"usgn")..' 0 "'..r)
			msg(color[2]..""..pl[id].name..""..color[1].." banned (USGN) "..color[2]..""..pl[t].name.." (Reason: "..r..")")
			return 1
		else
			error(id,txt,1)
			return 1
		end
	end
	if txt:sub(1,8)=="!tempban" then
		if pl[id].lvl >= 5 then
			t = tonumber(txt:sub(10,11))
			duration = txt:sub(12,14)
			r = txt:sub(15)
			if not player(t,"exists") then error(id,txt,2) return 1 end
			if player(t,"bot")==true then error(id,txt,3) return 1 end
			if tonumber(duration) > 60 then error(id,txt,7) return 1 end
				msg(color[2]..""..pl[id].name..""..color[1].." temp. banned "..color[2]..""..pl[t].name.." for "..color[1]..""..duration.." minutes "..color[2].."(Reason: "..r..")")
				if player(t,"usgn")==0 then
					msg2(id,color[4].."Info: "..color[2]..""..player(t,"name").." was not logged in to USGN.")
					msg2(id,color[4].."Info: "..color[2].."Temporarily banned his IP ("..player(t,"ip")..")")
					parse('banip '..player(t,"ip")..' '..duration..' "'..r) 
					return 1
				else
					parse('banusgn '..player(t,"usgn")..' '..duration..' "'..r)
					return 1
				end
		else
			error(id,txt,1)
			return 1
		end
	end
	if txt:sub(1,5)=="!mute" then
		if pl[id].lvl >= 5 then
			t = tonumber(txt:sub(7,8))
			reason = txt:sub(9)
			if pl[t].muted==false then
				pl[t].muted=true
				msg2(id,color[2]..""..pl[id].name..""..color[1].." muted "..color[2]..""..pl[t].name.." (Reason: "..reason)
				return 1
			else
				pl[t].muted=false
				msg2(id,color[2]..""..pl[id].name..""..color[1].." unmuted "..color[2]..""..pl[t].name)
				return 1
			end
		else
			error(id,txt,1)
			return 1
		end
	end
	if txt:sub(1,5)=="!kill" then
		if pl[id].lvl >= 5 then
			t = tonumber(txt:sub(7,8))
			if not player(t,"exists") then error(id,txt,2) return 1 end
			parse("killplayer "..t)
			msg(color[2]..""..pl[id].name..""..color[1].." command-killed "..color[2]..""..pl[t].name)
			return 1
		else
			error(id,txt,1)
			return 1
		end
	end
	if txt:sub(1,5)=="!slap" then
		if pl[id].lvl >= 5 then
			t = tonumber(txt:sub(7,8))
			if not player(t,"exists") then error(id,txt,2) return 1 end
			msg(color[2]..""..pl[id].name..""..color[1].." slapped "..color[2]..""..pl[t].name)
			parse("slap "..t)
			return 1
		else
			error(id,txt,1)
			return 1
		end
	end
	if txt:sub(1,6)=="!unban" then
		if pl[id].lvl >= 10 then
			mask = txt:sub(8)
			parse("unban "..mask)
			msg2(id,color[4].."Info:"..color[2].." Successfully unbanned "..color[1]..""..mask)
			return 1
		else
			error(id,txt,1)
			return 1
		end
	end
	if txt:sub(1,6)=="!strip" then
		if pl[id].lvl >= 5 then
			t = tonumber(txt:sub(8,9))
			if not player(t,"exists") then error(id,txt,2) return 1 end
			msg(color[2]..""..pl[id].name..""..color[1].." stripped "..color[2]..""..pl[t].name)
			parse("strip "..t)
			return 1
		else
			error(id,txt,1)
			return 1
		end
	end
	if txt:sub(1,6)=="!speed" then
		if pl[id].lvl >= 10 then
			t = tonumber(txt:sub(8,9))
			speed = tonumber(txt:sub(10,12))
			parse("speedmod "..t.." "..speed)
			msg(color[2]..""..pl[id].name..""..color[1].." speedmod ("..speed..") "..color[2]..""..pl[t].name)
			return 1
		else
			error(id,txt,1)
			return 1
		end
	end
	if txt:sub(1,6)=="!equip" then
		if pl[id].lvl >= 5 then
			t = tonumber(txt:sub(8,9))
			item = tonumber(txt:sub(10,12))
			parse("equip "..t.." "..item)
			msg2(t,color[2]..""..pl[id].name.." gave you item #"..item)
			return 1
		else
			error(id,txt,1)
			return 1
		end
	end			
	if txt:sub(1,5)=="!info" then
		if pl[id].lvl >= 5 then
			t = tonumber(txt:sub(7,8))
			if not player(t,"exists") then error(id,txt,2) return 1 end
			msg2(id,color[2].."Name: "..pl[t].name)
			msg2(id,color[2].."USGN: "..pl[t].usgn)
			msg2(id,color[2].."IP: "..pl[t].ip)
			return 1
		else
			error(id,txt,1)
			return 1
		end
	end
	if txt:sub(1,4)=="!map" then
		if pl[id].lvl >= 10 then
			map = txt:sub(6)
			msg(color[2]..""..pl[id].name.." changed the map to "..color[1]..""..map)
			timer(2000,"parse","map "..map)
			return 1
		else
			error(id,txt,1)
			return 1
		end
	end
	if txt=="!tag" then
		if pl[id].lvl >= 5 then
			if pl[id].has_tag == true then
				pl[id].has_tag = false
				msg2(id,color[2].."Tag: "..color[3].."OFF")
				return 1
			else
				pl[id].has_tag = true
				msg2(id,color[2].."Tag: "..color[4].."ON")
				return 1
			end
		else
			error(id,txt,1)
			return 1
		end
	end
	if txt:sub(1,8)=="!restart" then --!restart 99
		if pl[id].lvl >= 5 then
			local t = tonumber(txt:sub(10,11))
			if t <=10 then
				msg2(id,color[2]..""..pl[id].name.." called a "..color[1].."round restart "..color[2].."in "..color[1]..""..t.." "..color[2].."seconds")
				parse("restartround "..t)
				return 1
			else
				error(id,txt,5)
				return 1
			end
		else
			error(id,txt,1)
			return 1
		end
	end
	if txt=="!reload" then
		if pl[id].lvl >= 10 then
			msg(color[2]..""..pl[id].name..""..color[1].." reloaded"..color[1].." the server.")
			reload()
			return 1
		else
			error(id,txt,1)
			return 1
		end
	end
	if txt:sub(1,5)=="!rcon" then
		if pl[id].lvl >= 15 then 
			local cmd = txt:sub(7)
			parse(cmd)
			msg2(id,color[4].."Successfully parsed "..color[1]..""..cmd)
			msg(color[2]..""..pl[id].name..""..color[1].." parsed"..color[1].." "..cmd)
			return 1
		else 
			error(id,txt,1)
			return 1
		end
	end
	if txt:sub(1,3)=="!pm" then
		local t = tonumber(txt:sub(5,6))
		local message = txt:sub(7)
		if not player(t,"exists") then error(id,txt,2) return 1 end
		msg2(id,color[7].."You whisper "..pl[t].name..": "..message)
		msg2(t,color[7]..""..pl[id].name.." whispers you: "..message)
		parse("sv_sound2 "..t.." alert.wav")
		return 1
	end
	if txt=="!resetscore" then
		if player(id,"deaths") > 0 or player(id,"score") > 0 then
			parse("setscore "..id.." 0")
			parse("setdeaths "..id.." 0")
			msg2(id,color[4].."Info: "..color[2].."You nullified your score")
			return 1
		else
			error(id,txt,6)
			return 1
		end
	end
	if txt=="!help" then
	msg2(id,color[4].."Info: "..color[2].."Please open up your console to see the commands.")
	msg2(id,color[2].."!help")
	msg2(id,color[2].."!pm <id>")
	msg2(id,color[2].."!resetscore")
		if pl[id].lvl >= 5 then
			msg2(id,color[2].."!kick <id> <reason>")
			msg2(id,color[2].."!banip <id> <reason>")
			msg2(id,color[2].."!banusgn <id> <reason>")
			msg2(id,color[2].."!tempban <id> <duration (1-1440 minutes)> <reason>")
			msg2(id,color[2].."!mute <id> <reason>")
			msg2(id,color[2].."!kill <id>")
			msg2(id,color[2].."!slap <id>")
			msg2(id,color[2].."!strip <id>")
			msg2(id,color[2].."!equip <id>")
			msg2(id,color[2].."!info <id>")
			msg2(id,color[2].."!tag")
			msg2(id,color[2].."!restart <time>")
		end
		if pl[id].lvl==10 then
			msg2(id,color[2].."!unban <mask>")
			msg2(id,color[2].."!speed <id> <speed 1-100>")
			msg2(id,color[2].."!map <map>")
			msg2(id,color[2].."!reload")
		end
		if pl[id].lvl==15 then
			msg2(id,color[2].."!rcon <cmd>")
		end
		return 1
	end
	if pl[id].lvl >= 5 and pl[id].has_tag == true then
		if player(id,"team")==1 then
			msg(color[10]..""..pl[id].tag.." "..color[8]..""..pl[id].name..": "..color[1]..""..txt) -- tag
			return 1
		elseif player(id,"team")==2 then
			msg(color[10]..""..pl[id].tag.." "..color[9]..""..pl[id].name..": "..color[1]..""..txt)
			return 1
		end
	end
end

function _serveraction(id,act)
	if act==3 then
		if pl[id].lvl>=5 and mod_wallhack == true then
			reqcld(id,2)
			parse("setpos "..id.." "..wallhack_x.." "..wallhack_y)
		end
	end
end

function _clientdata(id,mode,data1,data2)
	if mode==2 then
		wallhack_x = data1
		wallhack_y = data2
	end
end

function _startround(id)
	if sv_gamemode==0 and mp_startmoney==16000 then
		for i = 1,32 do 
			parse("setmoney "..i.." 16000")
		end
	end
end